def zeta(x)
  r2d  = 360.0/(2.0*Math::PI)  # Radians to degrees
  2.0*(Math.sin (x/r2d))*(Math.cos (x/r2d))
end

$fast_zeta = []

(0..900).each {|x| $fast_zeta[x]=zeta(x/10.0)}

def fast_zeta(x)
  $fast_zeta[(x*10).round]
end

y1 = zeta(37.5)                   # Slow

y2 = fast_zeta(37.5)              # Somewhat faster

y3 = $fast_zeta[(37.5*10).round]  # Still faster
