# Define level of precedence
    
def level(opr)
  case opr
    when "*", "/"
      2
    when "+", "-"
      1
    when "("
      0
  end
end


# "Main"

infix = "(a+b)*(c-d)/(e-(f-g))"
postfix = ""

stack = Stack.new

infix.each_byte do |sym|
  sym = "" << sym   # Convert to string
  case sym
    when "("
      stack.push sym

    when /[a-z]/
      postfix += sym

    when "*", "/", "+", "-"
      finished = false
      until finished or stack.empty?
        if level(sym) > level(stack.peek)
          finished = true
        else
          postfix += stack.pop
        end
      end
      stack.push sym

    when ")"
      while stack.peek != "("
        postfix += stack.pop
      end
      stack.pop  # Get rid of paren on stack
  end    
end
    
while !stack.empty?
  postfix += stack.pop
end

puts postfix            # Prints "ab+cd-*efg--/"
